GNU logs - #34022, boring messages


Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#34022: 26.1; Region highlight has lower priority than flymake overlays
Resent-From: Johann =?UTF-8?Q?Kl=C3=A4hn?= <johann@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Wed, 09 Jan 2019 20:39:02 +0000
Resent-Message-ID: <handler.34022.B.154706631127941 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: report 34022
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: 34022 <at> debbugs.gnu.org
Cc: =?UTF-8?Q?Jo=C3=A3o_?= =?UTF-8?Q?T=C3=A1vora?= <joaotavora@HIDDEN>
X-Debbugs-Original-To: bug-gnu-emacs@HIDDEN
Received: via spool by submit <at> debbugs.gnu.org id=B.154706631127941
          (code B ref -1); Wed, 09 Jan 2019 20:39:02 +0000
Received: (at submit) by debbugs.gnu.org; 9 Jan 2019 20:38:31 +0000
Received: from localhost ([127.0.0.1]:52587 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ghKcR-0007GZ-DK
	for submit <at> debbugs.gnu.org; Wed, 09 Jan 2019 15:38:31 -0500
Received: from eggs.gnu.org ([209.51.188.92]:45677)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <johann@HIDDEN>) id 1ghKXu-00078r-Gr
 for submit <at> debbugs.gnu.org; Wed, 09 Jan 2019 15:33:51 -0500
Received: from lists.gnu.org ([209.51.188.17]:49820)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <johann@HIDDEN>) id 1ghKXp-0003y3-4p
 for submit <at> debbugs.gnu.org; Wed, 09 Jan 2019 15:33:45 -0500
Received: from eggs.gnu.org ([209.51.188.92]:55877)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <johann@HIDDEN>) id 1ghKXn-0005BR-DH
 for bug-gnu-emacs@HIDDEN; Wed, 09 Jan 2019 15:33:45 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.1 required=5.0 tests=BAYES_50,RCVD_IN_DNSWL_LOW
 autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <johann@HIDDEN>) id 1ghKXl-0003xB-NF
 for bug-gnu-emacs@HIDDEN; Wed, 09 Jan 2019 15:33:43 -0500
Received: from out1-smtp.messagingengine.com ([66.111.4.25]:57901)
 by eggs.gnu.org with esmtps (TLS1.0:DHE_RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <johann@HIDDEN>) id 1ghKXl-0003uy-Ed
 for bug-gnu-emacs@HIDDEN; Wed, 09 Jan 2019 15:33:41 -0500
Received: from compute7.internal (compute7.nyi.internal [10.202.2.47])
 by mailout.nyi.internal (Postfix) with ESMTP id 282C421908;
 Wed,  9 Jan 2019 15:33:39 -0500 (EST)
Received: from web4 ([10.202.2.214])
 by compute7.internal (MEProxy); Wed, 09 Jan 2019 15:33:39 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=jklaehn.de; h=
 message-id:from:to:cc:mime-version:content-transfer-encoding
 :content-type:subject:date; s=fm2; bh=V14HwTGMvAmYDqifsiy+VrFwpY
 vJhXRw9Ic5RoK5okQ=; b=SF8oGYwCEhQ9sxqWZDB+1zzjfHlPFCzRMPHF0C7Z3T
 5gTlH7fwRdXYgxplAmiWfMa2fdGYzFmUiasEXnSurQ6wTf+k0Mef/yCdiN1BEAXL
 SFq3ltN8PQg1dCT2ER5ukw1acnWqJ6O5d9YGWySyFMefDgH/IrK3OW80Xa21Sy+A
 aTMV1yETZ5gt90SuO12Ab8d3E+TjQ1UQ+pWYzKCXl/Fqao+NvIIMiBhOqoeGruUi
 6Bxa1sgZNlv7VzjzV0hB3QFQNSkKs3o/0VFNKyvB2gp//20/FxwghTllg3yu8SRa
 23pSOJCAY1UePTC/cvRX+H95HeQm5YROBTW8dzOo3c0Q==
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=
 messagingengine.com; h=cc:content-transfer-encoding:content-type
 :date:from:message-id:mime-version:subject:to:x-me-proxy
 :x-me-proxy:x-me-sender:x-me-sender:x-sasl-enc; s=fm1; bh=V14HwT
 GMvAmYDqifsiy+VrFwpYvJhXRw9Ic5RoK5okQ=; b=p5x2+0DW4YgcHhF0+qo8dp
 6wFn4MfFEWql4VgOiitfJsuHlJwoUv5WkmVkl4sWq6DNhg/B5/tlbUJ3sxFKyjYI
 DkJ3LTYrQwB9qv7G3Qbcu3z2tXy8Zn+jJ2+dfbvh8yVevJmu6DqhyHjRFyrjP25w
 hJoPC20iv23b3iLmnYarP6BS7aWcLnVAxw6LTOWDmqWaq92o3Gc65pT1wqmCJqet
 Sa+iilRX7wL9t5idRxpOd9MZxeDVGnjqXq6Jl9UdsReqdTd7Hv1wEw62ibY9xRYx
 Ai96s/unGpahCSX3gBsqyPFU8bQX2Tm4PR8foIB86COLtWjYMpFacP36dAAjbyVg
 ==
X-ME-Sender: <xms:olo2XHJKvVpTgZIBtDsfGiPq7ES6llfwjqs9Z6zSZBinZrnpx19ELw>
X-ME-Proxy-Cause: gggruggvucftvghtrhhoucdtuddrgedtledrfedugddugedtucdltddurdegtdekrddttd
 dmucetufdoteggodetrfdotffvucfrrhhofhhilhgvmecuhfgrshhtofgrihhlpdfquhht
 necuuegrihhlohhuthemuceftddtnecusecvtfgvtghiphhivghnthhsucdlqddutddtmd
 enucfjughrpefkhffvggfgtgfoufffsehtqhertdertdejnecuhfhrohhmpeflohhhrghn
 nhcumfhlmohhnhcuoehjohhhrghnnhesjhhklhgrvghhnhdruggvqeenucfrrghrrghmpe
 hmrghilhhfrhhomhepjhhohhgrnhhnsehjkhhlrggvhhhnrdguvgenucevlhhushhtvghr
 ufhiiigvpedt
X-ME-Proxy: <xmx:olo2XPkscIQc6D7iwsfTEqVFt5KQBCEepUAJJPMGhWuLqJTXjD8czA>
 <xmx:olo2XLDw72t8-BRpnu9ICP6MtMyLpntminZFwnF870zvrub0k5rEaQ>
 <xmx:olo2XNtGTOwCfUVnMiPGVTr2W1FhIhgeDgGC7VmtDHyk89bXn4TOFQ>
 <xmx:o1o2XL52qCbizkT1sGszpn9898Pp329F8voz3l5aodVCiK3XF43Mag>
Received: by mailuser.nyi.internal (Postfix, from userid 99)
 id C4FEFBA784; Wed,  9 Jan 2019 15:33:37 -0500 (EST)
Message-Id: <1547066017.2291240.1630221536.19E9AC39@HIDDEN>
From: Johann =?UTF-8?Q?Kl=C3=A4hn?= <johann@HIDDEN>
MIME-Version: 1.0
Content-Transfer-Encoding: quoted-printable
Content-Type: text/plain; charset="utf-8"
X-Mailer: MessagingEngine.com Webmail Interface - ajax-5ae1f753
Date: Wed, 09 Jan 2019 21:33:37 +0100
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 66.111.4.25
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Spam-Score: 0.7 (/)
X-Mailman-Approved-At: Wed, 09 Jan 2019 15:38:29 -0500
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.3 (/)

I just noticed a bug (?) that region becomes de-facto "invisible" due to it=
s highlight overlay having a lower priority than the flymake overlays. This=
 only happens when both region and flymake diagnostics are indicated using =
the same face property (background in my case). It becomes more apparent fo=
r larger flymake overlays.

Steps to reproduce, starting from emacs -Q:

=E2=80=A2 M-: (set-face-background flymake-note "yellow green")
=E2=80=A2 M-x find-library flymake (or any file where there will be flymake=
 diagnostics)
=E2=80=A2 M-x flymake-mode
=E2=80=A2 Jump to a docstring/line/paragraph highlighted using e.g. the `fl=
ymake-note' face.
=E2=80=A2 With transient-mark-mode enabled select regions that overlap with=
 the
  flymake overlay. =E2=87=92 The region is not highlighted since the backgr=
ound
 face property given by the flymake overlay takes precedence.

Relevant extract from simple.el.gz, where the secondary priority for
the region highlight overlay is set to 100:

> (defvar redisplay-highlight-region-function
>   (lambda (start end window rol)
>     (if (not (overlayp rol))
>         (let ((nrol (make-overlay start end)))
>           (funcall redisplay-unhighlight-region-function rol)
>           (overlay-put nrol 'window window)
>           (overlay-put nrol 'face 'region)
>           ;; Normal priority so that a large region doesn't hide all the
>           ;; overlays within it, but high secondary priority so that if it
>           ;; ends/starts in the middle of a small overlay, that small ove=
rlay
>           ;; won't hide the region's boundaries.
>           (overlay-put nrol 'priority '(nil . 100))
>           nrol)
>       (unless (and (eq (overlay-buffer rol) (current-buffer))
>                    (eq (overlay-start rol) start)
>                    (eq (overlay-end rol) end))
>         (move-overlay rol start end (current-buffer)))
>       rol)))

Flymake uses 100 as the offset to compute the default priority for its over=
lays:

> (defun flymake--highlight-line (diagnostic)
>   "Highlight buffer with info in DIAGNOSTIC."
>   (when-let* ((ov (make-overlay
>                    (flymake--diag-beg diagnostic)
>                    (flymake--diag-end diagnostic))))
>     ;; First set `category' in the overlay, then copy over every other
>     ;; property.
>     ;;
>     (let ((alist (assoc-default (flymake--diag-type diagnostic)
>                                 flymake-diagnostic-types-alist)))
>       (overlay-put ov 'category (assoc-default 'flymake-category alist))
>       (cl-loop for (k . v) in alist
>                unless (eq k 'category)
>                do (overlay-put ov k v)))
>     ;; Now ensure some essential defaults are set
>     ;;
>     (cl-flet ((default-maybe
>                 (prop value)
>                 (unless (or (plist-member (overlay-properties ov) prop)
>                             (let ((cat (overlay-get ov
>                                                     'flymake-category)))
>                               (and cat
>                                    (plist-member (symbol-plist cat) prop)=
)))
>                   (overlay-put ov prop value))))
>       (default-maybe 'bitmap 'flymake-error-bitmap)
>       (default-maybe 'face 'flymake-error)
>       (default-maybe 'before-string
>         (flymake--fringe-overlay-spec
>          (overlay-get ov 'bitmap)))
>       (default-maybe 'help-echo
>         (lambda (window _ov pos)
>           (with-selected-window window
>             (mapconcat
>              #'flymake--diag-text
>              (flymake-diagnostics pos)
>              "\n"))))
>       (default-maybe 'severity (warning-numeric-level :error))
>       (default-maybe 'priority (+ 100 (overlay-get ov 'severity))))
>     ;; Some properties can't be overridden.
>     ;;
>     (overlay-put ov 'evaporate t)
>     (overlay-put ov 'flymake-diagnostic diagnostic)))

Is it intentional that 100 is used as the offset here? This has the effect =
that most priorities will be above that of the region overlay.

---

In GNU Emacs 26.1 (build 1, x86_64-pc-linux-gnu, GTK+ Version 3.22.30)
 of 2018-07-05 built on juergen
Windowing system distributor 'The X.Org Foundation', version 11.0.12003000
Recent messages:

Configured using:
 'configure --prefix=3D/usr --sysconfdir=3D/etc --libexecdir=3D/usr/lib
 --localstatedir=3D/var --with-x-toolkit=3Dgtk3 --with-xft --with-modules
 'CFLAGS=3D-march=3Dx86-64 -mtune=3Dgeneric -O2 -pipe -fstack-protector-str=
ong
 -fno-plt' CPPFLAGS=3D-D_FORTIFY_SOURCE=3D2
 LDFLAGS=3D-Wl,-O1,--sort-common,--as-needed,-z,relro,-z,now'

Configured features:
XPM JPEG TIFF GIF PNG RSVG IMAGEMAGICK SOUND GPM DBUS GSETTINGS NOTIFY
ACL GNUTLS LIBXML2 FREETYPE M17N_FLT LIBOTF XFT ZLIB TOOLKIT_SCROLL_BARS
GTK3 X11 MODULES THREADS LIBSYSTEMD LCMS2

Important settings:
  value of $LC_ALL: en_US.UTF-8
  value of $LC_MESSAGES: C
  value of $LANG: de_DE.utf8
  locale-coding-system: utf-8-unix

Major mode: Emacs-Lisp

Minor modes in effect:
  flymake-mode: t
  tooltip-mode: t
  global-eldoc-mode: t
  eldoc-mode: t
  electric-indent-mode: t
  mouse-wheel-mode: t
  tool-bar-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  blink-cursor-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  buffer-read-only: t
  line-number-mode: t
  transient-mark-mode: t

Load-path shadows:
None found.

Features:
(shadow sort mail-extr emacsbug message rmc puny seq dired
dired-loaddefs format-spec rfc822 mml mml-sec password-cache epa derived
epg epg-config gnus-util rmail rmail-loaddefs mm-decode mm-bodies
mm-encode mail-parse rfc2231 mailabbrev gmm-utils mailheader sendmail
rfc2047 rfc2045 ietf-drums mm-util mail-prsvr mail-utils cl-extra
help-fns radix-tree cl-print byte-opt bytecomp byte-compile cconv debug
face-remap misearch multi-isearch noutline outline easy-mmode lisp-mnt
checkdoc cl-macs gv cl-seq flymake-proc flymake compile comint
ansi-color ring warnings help-mode easymenu cl-loaddefs cl-lib jka-compr
thingatpt find-func elec-pair time-date mule-util tooltip eldoc electric
uniquify ediff-hook vc-hooks lisp-float-type mwheel term/x-win x-win
term/common-win x-dnd tool-bar dnd fontset image regexp-opt fringe
tabulated-list replace newcomment text-mode elisp-mode lisp-mode
prog-mode register page menu-bar rfn-eshadow isearch timer select
scroll-bar mouse jit-lock font-lock syntax facemenu font-core
term/tty-colors frame cl-generic cham georgian utf-8-lang misc-lang
vietnamese tibetan thai tai-viet lao korean japanese eucjp-ms cp51932
hebrew greek romanian slovak czech european ethiopic indian cyrillic
chinese composite charscript charprop case-table epa-hook jka-cmpr-hook
help simple abbrev obarray minibuffer cl-preloaded nadvice loaddefs
button faces cus-face macroexp files text-properties overlay sha1 md5
base64 format env code-pages mule custom widget hashtable-print-readable
backquote dbusbind inotify lcms2 dynamic-setting system-font-setting
font-render-setting move-toolbar gtk x-toolkit x multi-tty
make-network-process emacs)

Memory information:
((conses 16 123857 7080)
 (symbols 48 22067 1)
 (miscs 40 144 289)
 (strings 32 35534 1170)
 (string-bytes 1 922022)
 (vectors 16 17358)
 (vector-slots 8 524383 14202)
 (floats 8 67 298)
 (intervals 56 2057 393)
 (buffers 992 18))




Message sent:


Content-Disposition: inline
Content-Transfer-Encoding: quoted-printable
MIME-Version: 1.0
X-Mailer: MIME-tools 5.505 (Entity 5.505)
Content-Type: text/plain; charset=utf-8
X-Loop: help-debbugs@HIDDEN
From: help-debbugs@HIDDEN (GNU bug Tracking System)
To: Johann =?UTF-8?Q?Kl=C3=A4hn?= <johann@HIDDEN>
Subject: bug#34022: Acknowledgement (26.1; Region highlight has lower
 priority than flymake overlays)
Message-ID: <handler.34022.B.154706631127941.ack <at> debbugs.gnu.org>
References: <1547066017.2291240.1630221536.19E9AC39@HIDDEN>
X-Gnu-PR-Message: ack 34022
X-Gnu-PR-Package: emacs
Reply-To: 34022 <at> debbugs.gnu.org
Date: Wed, 09 Jan 2019 20:39:02 +0000

Thank you for filing a new bug report with debbugs.gnu.org.

This is an automatically generated reply to let you know your message
has been received.

Your message is being forwarded to the package maintainers and other
interested parties for their attention; they will reply in due course.

Your message has been sent to the package maintainer(s):
 bug-gnu-emacs@HIDDEN

If you wish to submit further information on this problem, please
send it to 34022 <at> debbugs.gnu.org.

Please do not send mail to help-debbugs@HIDDEN unless you wish
to report a problem with the Bug-tracking system.

--=20
34022: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=3D34022
GNU Bug Tracking System
Contact help-debbugs@HIDDEN with problems


Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#34022: 26.1; Region highlight has lower priority than flymake overlays
Resent-From: =?UTF-8?Q?Jo=C3=A3o_?= =?UTF-8?Q?T=C3=A1vora?= <joaotavora@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Wed, 09 Jan 2019 20:53:02 +0000
Resent-Message-ID: <handler.34022.B.15470671444540 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 34022
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Johann =?UTF-8?Q?Kl=C3=A4hn?= <johann@HIDDEN>
Cc: 34022 <at> debbugs.gnu.org
X-Debbugs-Original-Cc: bug-gnu-emacs@HIDDEN
Received: via spool by submit <at> debbugs.gnu.org id=B.15470671444540
          (code B ref -1); Wed, 09 Jan 2019 20:53:02 +0000
Received: (at submit) by debbugs.gnu.org; 9 Jan 2019 20:52:24 +0000
Received: from localhost ([127.0.0.1]:52612 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ghKps-0001B9-6F
	for submit <at> debbugs.gnu.org; Wed, 09 Jan 2019 15:52:24 -0500
Received: from eggs.gnu.org ([209.51.188.92]:49911)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <joaotavora@HIDDEN>) id 1ghKpq-0001Aw-FZ
 for submit <at> debbugs.gnu.org; Wed, 09 Jan 2019 15:52:22 -0500
Received: from lists.gnu.org ([209.51.188.17]:47137)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <joaotavora@HIDDEN>)
 id 1ghKpl-0006fl-9n
 for submit <at> debbugs.gnu.org; Wed, 09 Jan 2019 15:52:17 -0500
Received: from eggs.gnu.org ([209.51.188.92]:60112)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <joaotavora@HIDDEN>) id 1ghKpk-0000lI-Ex
 for bug-gnu-emacs@HIDDEN; Wed, 09 Jan 2019 15:52:17 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: *
X-Spam-Status: No, score=1.8 required=5.0 tests=BAYES_50,FREEMAIL_FROM,
 FROM_EXCESS_BASE64 autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <joaotavora@HIDDEN>) id 1ghKpj-0006f0-GE
 for bug-gnu-emacs@HIDDEN; Wed, 09 Jan 2019 15:52:16 -0500
Received: from mail-wm1-x32e.google.com ([2a00:1450:4864:20::32e]:36515)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <joaotavora@HIDDEN>)
 id 1ghKpj-0006ea-AY
 for bug-gnu-emacs@HIDDEN; Wed, 09 Jan 2019 15:52:15 -0500
Received: by mail-wm1-x32e.google.com with SMTP id p6so9777754wmc.1
 for <bug-gnu-emacs@HIDDEN>; Wed, 09 Jan 2019 12:52:15 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version:content-transfer-encoding;
 bh=JUNu3WagvM4C1c2M/nLXay5jfNximI0r3IinhSNv7Hg=;
 b=Yo8rkAz9YOFW8LowQK/RRb8V0YM5IK2EBDgs9ykBJzzxqYftcPzDZSUM9SMZ6KbMou
 3Eq9egcDHm6dbD2/zEwz6ssiLTkP6r45cCaPU1UguC8ZRnxLrzESb69PTIAWXx15b5FI
 SEzsiGpEeaSd/fXdjkHzLSxwSjR5fv9DOn3QmiWOTmZpeaaqxAyGmvm/pjalKijat9X/
 WD4M4DBQb/xUmp3NyaT+ZgM0aQtx/ScUC3jSOKWOxGx83NpFUF5OKbeFW1XScf8Bm12G
 bJU5POW48gsaVQQLyxJn4wJGLUTG8uPvewqs5toZe1Pg2K2f8/Vm0ES58UuihMKwG6d6
 iBuA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version:content-transfer-encoding;
 bh=JUNu3WagvM4C1c2M/nLXay5jfNximI0r3IinhSNv7Hg=;
 b=THuxiBWWmm0EYUghLGS44VtaQ9DsdiUseYepBU6rHtdteWXDSxY1fj24zQR/mFxLeA
 ph9p5tDx+OvbR3xnyzhfAAwQvndQkxsRngGTG+t8WcjP7j0FFqcawyOn/1BYfCQAA80h
 kmZP6A95Fp1huJNy5g1OCzsuOxU1Wypd+/T3ZpEWRWIfz4E7WLc+dRi3NLkhahncXSy6
 GJR2/N6g4BfjTMR7rA0vYHwWnltfq4WELwHJej98on1Qa1XftJ1AZsG1EaA7dW7fRlgh
 /old64q2DcR01BzZFToZO7sV/2LBcn2isQcMViMti2nvKiIVeme537tR83hkN9DBBo/e
 tRmg==
X-Gm-Message-State: AJcUuke2KBnuYeTrCBNIeh9vzkPKXTR+lFDeOEpeIRdcM9mvsy8L9WVD
 idyc0x21kaMyyTCg51mbsXWvpOMA
X-Google-Smtp-Source: ALg8bN4hBZS680dd+1dIfQzCIsKFW6mvCu0Go8Kwp62b8hsweMf6cIi10cXRUZsXTzbWnyO6wi5ifw==
X-Received: by 2002:a1c:2e0c:: with SMTP id u12mr7176561wmu.81.1547067133720; 
 Wed, 09 Jan 2019 12:52:13 -0800 (PST)
Received: from lolita.yourcompany.com (188.139.62.94.rev.vodafone.pt.
 [94.62.139.188])
 by smtp.gmail.com with ESMTPSA id i13sm55339016wrw.32.2019.01.09.12.52.12
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Wed, 09 Jan 2019 12:52:12 -0800 (PST)
From: =?UTF-8?Q?Jo=C3=A3o_?= =?UTF-8?Q?T=C3=A1vora?= <joaotavora@HIDDEN>
References: <1547066017.2291240.1630221536.19E9AC39@HIDDEN>
Date: Wed, 09 Jan 2019 20:52:05 +0000
In-Reply-To: <1547066017.2291240.1630221536.19E9AC39@HIDDEN>
 ("Johann \=\?utf-8\?Q\?Kl\=C3\=A4hn\=22's\?\= message of "Wed,
 09 Jan 2019 21:33:37 +0100")
Message-ID: <87ftu1lfka.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
 recognized.
X-Received-From: 2a00:1450:4864:20::32e
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Spam-Score: 1.1 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Johann =?UTF-8?Q?Kl=C3=A4hn?= writes: > I just noticed a bug (?) that region
    becomes de-facto "invisible" due > to its highlight overlay having a lower
    priority than the flymake > overlays. This only happens when both region
   and flymake d [...] 
 
 Content analysis details:   (1.1 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
                             provider (joaotavora[at]gmail.com)
  1.0 SPF_SOFTFAIL           SPF: sender does not match SPF record (softfail)
  0.1 FROM_EXCESS_BASE64     From: base64 encoded unnecessarily
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.1 (/)

Johann Kl=C3=A4hn <johann@HIDDEN> writes:

> I just noticed a bug (?) that region becomes de-facto "invisible" due
> to its highlight overlay having a lower priority than the flymake
> overlays. This only happens when both region and flymake diagnostics
> are indicated using the same face property (background in my case). It
> becomes more apparent for larger flymake overlays.
>
> Steps to reproduce, starting from emacs -Q:
>
> =E2=80=A2 M-: (set-face-background flymake-note "yellow green")

You probably mean=20

(set-face-background 'flymake-note "yellow green")

> Flymake uses 100 as the offset to compute the default priority for its
> overlays:
> Is it intentional that 100 is used as the offset here? This has the
> effect that most priorities will be above that of the region overlay.

Yes, it was intentional.  Doesn't mean that it's correct :-) Perhaps it
should be reduced to the 50's region and also use the (nil . <value>),
form which I didn't know about (so thanks for showing me this).

I don't know if there are any guide-lines for interoperation in this
front, so if someone more knowledgeable than me want to chime in...

Anyway, for now, you can probably work around this with

   (push '(priority . (nil . 50)) (get :note 'flymake-overlay-control))

Jo=C3=A3o




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#34022: 26.1; Region highlight has lower priority than flymake overlays
Resent-From: Johann =?UTF-8?Q?Kl=C3=A4hn?= <johann@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Thu, 10 Jan 2019 21:17:01 +0000
Resent-Message-ID: <handler.34022.B.15471549714583 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 34022
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: =?UTF-8?Q?Jo=C3=A3o_?= =?UTF-8?Q?T=C3=A1vora?= <joaotavora@HIDDEN>
Cc: 34022 <at> debbugs.gnu.org, eliz@HIDDEN
X-Debbugs-Original-Cc: bug-gnu-emacs@HIDDEN, Eli Zaretskii <eliz@HIDDEN>
Received: via spool by submit <at> debbugs.gnu.org id=B.15471549714583
          (code B ref -1); Thu, 10 Jan 2019 21:17:01 +0000
Received: (at submit) by debbugs.gnu.org; 10 Jan 2019 21:16:11 +0000
Received: from localhost ([127.0.0.1]:54333 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ghhgP-0001Bo-L5
	for submit <at> debbugs.gnu.org; Thu, 10 Jan 2019 16:16:11 -0500
Received: from eggs.gnu.org ([209.51.188.92]:42018)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <johann@HIDDEN>) id 1ghhgO-0001BW-Dv
 for submit <at> debbugs.gnu.org; Thu, 10 Jan 2019 16:16:08 -0500
Received: from lists.gnu.org ([209.51.188.17]:34492)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <johann@HIDDEN>) id 1ghhgI-000339-VK
 for submit <at> debbugs.gnu.org; Thu, 10 Jan 2019 16:16:03 -0500
Received: from eggs.gnu.org ([209.51.188.92]:52087)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <johann@HIDDEN>) id 1ghhgF-0004oJ-Oy
 for bug-gnu-emacs@HIDDEN; Thu, 10 Jan 2019 16:16:02 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.1 required=5.0 tests=BAYES_50,RCVD_IN_DNSWL_LOW
 autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <johann@HIDDEN>) id 1ghhXI-0005vF-Ti
 for bug-gnu-emacs@HIDDEN; Thu, 10 Jan 2019 16:06:45 -0500
Received: from wout2-smtp.messagingengine.com ([64.147.123.25]:44681)
 by eggs.gnu.org with esmtps (TLS1.0:DHE_RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <johann@HIDDEN>)
 id 1ghhXI-0005v3-MC; Thu, 10 Jan 2019 16:06:44 -0500
Received: from compute7.internal (compute7.nyi.internal [10.202.2.47])
 by mailout.west.internal (Postfix) with ESMTP id B005215E4;
 Thu, 10 Jan 2019 16:06:43 -0500 (EST)
Received: from web4 ([10.202.2.214])
 by compute7.internal (MEProxy); Thu, 10 Jan 2019 16:06:43 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=jklaehn.de; h=
 message-id:from:to:cc:mime-version:content-transfer-encoding
 :content-type:in-reply-to:date:subject:references; s=fm2; bh=s0J
 9nKD/gEx0PUel2mMCehY1JRXM9qipWixUrv+n1gY=; b=pA3TNxAT0GSebRaoaKv
 5aZP6zf7mmgebVaj94ybtY/atpcsaolz3UQtiC2mqvDnWFPduK8fU+uVqEZdRPK5
 zQQEsReOjuEMCV9OXOStqth/YejZgYV+tiuAJMap4yFNeeymyTSL1mGJHwqHBIFy
 P17HBGueulh+qdAGgU+DX+fS304w16JHj3xuy4Lvq3ViSgbSJuks8DtDUV+tmg0K
 wjwe9KYM8Wfq0wXUdb3dvxGAWNY9wU1mvESAMoWsIGNU3CXr6HgtPwX0FRtkWUIL
 TajEU7IfltrlBfbXCS2wGMwfMTbzduhLUbPDPON0iNC80yP0Blt68Xhn4EB0sufU
 Gyg==
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=
 messagingengine.com; h=cc:content-transfer-encoding:content-type
 :date:from:in-reply-to:message-id:mime-version:references
 :subject:to:x-me-proxy:x-me-proxy:x-me-sender:x-me-sender
 :x-sasl-enc; s=fm1; bh=s0J9nKD/gEx0PUel2mMCehY1JRXM9qipWixUrv+n1
 gY=; b=GECmUNNWOa8KKE9iOnPO4qMQ/APTx6IR99yY3YRT0PuvH1l+lDIAZ5jJ0
 XsbM/0oqyLg7tiEvMlUF0WgoY0EA3S8C4xWpqfYhNXHXo3S1eF9a6WNvc/34lnHC
 G3PKt4Y9dC8+BEaNvu6lS5aU+qwFa5+7QZ62ZK4yyNjHuFnJuPBpZodA+9JKVvMk
 L9LgnrJ/eea+uT8qhXB7mhgg8ucwvanHhIG8O06/NevJCtpxIts+AF4foHKVnU7Q
 WzbjK1qmEQplRlfYAdNFnfQJjDJ8KqEKC0mqCQgDdkxx6W9nlZPZa8KBy05KA+pW
 QenXVOdrglanKFNLqShbC4smy+PSQ==
X-ME-Sender: <xms:47M3XCgd_k1j268o3d4ttgElCLkiKh2aZHioBzogevoyHY2hvi1P6w>
X-ME-Proxy-Cause: gggruggvucftvghtrhhoucdtuddrgedtledrfeefgddugeejucetufdoteggodetrfdotf
 fvucfrrhhofhhilhgvmecuhfgrshhtofgrihhlpdfquhhtnecuuegrihhlohhuthemucef
 tddtnecusecvtfgvtghiphhivghnthhsucdlqddutddtmdenucfjughrpefkhffvggfgtg
 fojgffufhfsehtqhertdertdejnecuhfhrohhmpeflohhhrghnnhcumfhlmohhnhcuoehj
 ohhhrghnnhesjhhklhgrvghhnhdruggvqeenucfrrghrrghmpehmrghilhhfrhhomhepjh
 hohhgrnhhnsehjkhhlrggvhhhnrdguvgenucevlhhushhtvghrufhiiigvpedt
X-ME-Proxy: <xmx:47M3XHRPabVKxjImqMskujShF2UtvHOyWDZRr6TrIW3eNfBlsACGBA>
 <xmx:47M3XFH503OQ7j5BL6_ZIa0ABES95tg3xtLxCpWjG9SsAh7g_cqOTg>
 <xmx:47M3XPn26uZpsq_Or8XAUt_CBCQ8DBhr1ruAooGavumSLXmbjs1eXg>
 <xmx:47M3XKGKFMyrIeSKQP8punwJn6heysFtB0PnRnGXlXQMPRu6S6n-3Q>
Received: by mailuser.nyi.internal (Postfix, from userid 99)
 id 0825EBA783; Thu, 10 Jan 2019 16:06:42 -0500 (EST)
Message-Id: <1547154402.1640373.1631290352.72E71BD4@HIDDEN>
From: Johann =?UTF-8?Q?Kl=C3=A4hn?= <johann@HIDDEN>
MIME-Version: 1.0
Content-Transfer-Encoding: quoted-printable
Content-Type: text/plain; charset="utf-8"
X-Mailer: MessagingEngine.com Webmail Interface - ajax-5ae1f753
In-Reply-To: <87ftu1lfka.fsf@HIDDEN>
Date: Thu, 10 Jan 2019 22:06:42 +0100
References: <1547066017.2291240.1630221536.19E9AC39@HIDDEN>
 <87ftu1lfka.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 64.147.123.25
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Spam-Score: 0.7 (/)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.3 (/)

(Sorry, I initially forgot to CC the bug tracker.)

Hi Jo=C3=A3o,

thanks for your quick response! I did not see `flymake-overlay-control' bec=
ause I was still using
the version of flymake shipped with Emacs 26.1. (I really like the options =
introduced with the new
version allows, so I will probably switch to using it.)

On Wed, Jan 9, 2019, at 21:52, Jo=C3=A3o T=C3=A1vora wrote:
> Johann Kl=C3=A4hn <johann@HIDDEN> writes:
> > =E2=80=A2 M-: (set-face-background flymake-note "yellow green")
>=20
> You probably mean=20
>=20
> (set-face-background 'flymake-note "yellow green")
Exactly :)

> Yes, it was intentional.  Doesn't mean that it's correct :-) Perhaps it
> should be reduced to the 50's region and also use the (nil . <value>),
> form which I didn't know about (so thanks for showing me this).

Wrt. to using non-numeric priority values maybe Eli Zaretskii could chime i=
n, because there is the
following section ("Overlay Properties") in the Emacs Lisp manual, which he=
 wrote (see Bug#20253):

=E2=80=96 =E2=80=98priority=E2=80=99
=E2=80=96      This property=E2=80=99s value determines the priority of the=
 overlay.  If
=E2=80=96      you want to specify a priority value, use either =E2=80=98ni=
l=E2=80=99 (or zero),
=E2=80=96      or a positive integer.  Any other value has undefined behavi=
or.
=E2=80=96      [...]
=E2=80=96      Note that Emacs sometimes uses non-numeric priority values f=
or some
=E2=80=96      of its internal overlays, so do not try to do arithmetic on =
the
=E2=80=96      priority of an overlay (unless it is one that you created). =
 In
=E2=80=96      particular, the overlay used for showing the region uses a p=
riority
=E2=80=96      value of the form =E2=80=98(PRIMARY . SECONDARY)=E2=80=99, w=
here the PRIMARY value
=E2=80=96      is used as described above, and SECONDARY is the fallback va=
lue
=E2=80=96      used when PRIMARY and the nesting considerations fail to res=
olve
=E2=80=96      the precedence between overlays.  However, you are advised n=
ot to
=E2=80=96      design Lisp programs based on this implementation detail; if=
 you
=E2=80=96      need to put overlays in priority order, use the SORTED argum=
ent of
=E2=80=96      =E2=80=98overlays-at=E2=80=99.  *Note Finding Overlays::.

Even though it's shipped with Emacs, flymake is probably not "internal" eno=
ugh to use those?

...looking around further I just found Bug#16192, where a similar problem w=
as fixed for hl-line-mode
by using a negative priority.  And then there is also Bug#15899, which disc=
usses the use of overlays
to highlight region in the first place.




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#34022: 26.1; Region highlight has lower priority than flymake overlays
Resent-From: =?UTF-8?Q?Jo=C3=A3o_?= =?UTF-8?Q?T=C3=A1vora?= <joaotavora@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Thu, 10 Jan 2019 22:05:01 +0000
Resent-Message-ID: <handler.34022.B.15471578469050 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 34022
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Johann =?UTF-8?Q?Kl=C3=A4hn?= <johann@HIDDEN>
Cc: 34022 <at> debbugs.gnu.org, eliz@HIDDEN
X-Debbugs-Original-Cc: bug-gnu-emacs@HIDDEN, Eli Zaretskii <eliz@HIDDEN>
Received: via spool by submit <at> debbugs.gnu.org id=B.15471578469050
          (code B ref -1); Thu, 10 Jan 2019 22:05:01 +0000
Received: (at submit) by debbugs.gnu.org; 10 Jan 2019 22:04:06 +0000
Received: from localhost ([127.0.0.1]:54355 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ghiQn-0002Lu-Tj
	for submit <at> debbugs.gnu.org; Thu, 10 Jan 2019 17:04:06 -0500
Received: from eggs.gnu.org ([209.51.188.92]:50865)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <joaotavora@HIDDEN>) id 1ghiQk-0002LE-MS
 for submit <at> debbugs.gnu.org; Thu, 10 Jan 2019 17:04:03 -0500
Received: from lists.gnu.org ([209.51.188.17]:52383)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <joaotavora@HIDDEN>)
 id 1ghiQe-0004zv-QJ
 for submit <at> debbugs.gnu.org; Thu, 10 Jan 2019 17:03:57 -0500
Received: from eggs.gnu.org ([209.51.188.92]:32833)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <joaotavora@HIDDEN>) id 1ghiQd-0006zb-O9
 for bug-gnu-emacs@HIDDEN; Thu, 10 Jan 2019 17:03:56 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: *
X-Spam-Status: No, score=1.8 required=5.0 tests=BAYES_50,FREEMAIL_FROM,
 FROM_EXCESS_BASE64 autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <joaotavora@HIDDEN>) id 1ghiQb-0004xq-KL
 for bug-gnu-emacs@HIDDEN; Thu, 10 Jan 2019 17:03:55 -0500
Received: from mail-wr1-x42d.google.com ([2a00:1450:4864:20::42d]:34786)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <joaotavora@HIDDEN>)
 id 1ghiQZ-0004wb-V9; Thu, 10 Jan 2019 17:03:52 -0500
Received: by mail-wr1-x42d.google.com with SMTP id j2so13171445wrw.1;
 Thu, 10 Jan 2019 14:03:51 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version:content-transfer-encoding;
 bh=+YAmmW5wLM641FocYzazOAgEfrTf/7Lr/dAQDpbIgi8=;
 b=A3xfEvLQMLM3lN5a6kVsOq9zqzTCiBnw4ZbpNIvX+JISJz7U1YWwUKosVtnVCN/hl4
 p4w9MBWT2WMbMfLFKpkwheniGf5ig1pfPvrS7R9RO99mn2Lnt6ec/psRxX9cG/V0ez6H
 8TpZEl/8cAiu5hhDrxBmRuZweTYynhDgC9Jduhe07TDchlFdz62G0pGDuZ7tTg1rvIs+
 i4EfPh+yzH85KS19pJ9HXdIRJmlm50BM7xOI+b0wCEj7bg1N4oH+0nQSuwihAf/zrqf6
 BY1tL1KOAgzgf6kpdNtnqQbqKv02sUeNBviPrsS7c1D5YUL6xO9pWwSHexeNlZorjQ1L
 rBNg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version:content-transfer-encoding;
 bh=+YAmmW5wLM641FocYzazOAgEfrTf/7Lr/dAQDpbIgi8=;
 b=btVxC9EpBjOuqE9YBnCMP8qewsYkt3r+m/+MGAgXDe4ypycUMdQ0vWcBCQ+8XmJ7rF
 bgA3reZ7nFRN43aZXm7tpFcXHs9P6FK5DfS9pOgYSJPxSQF3T4fnGAO3natCiyzPiff8
 Z6FotsvRBfI2hvEH9hcPbT/QXSFfGxpsXa7GWJtx1tLKwnWvQRoGMFg1AJEZZ9FpEECr
 0UNQR8iTzW0COMTxF1GyttBYX3CQ5JnjkbRE8mTSrNDvZpjf3+1iOgh4tCFaJbgFUISf
 6Rk9uJm1C7L7si/hkQR3ZJZmUfpJNhhsVE89dJV7EtusBuTgJt2vi2bVdL3Kfvd1TEzv
 whMQ==
X-Gm-Message-State: AJcUukd9sHHPyFO2dVISvEVA1ahcWGzNPpGNRnlVWHNgjYLMWcp+NYrE
 y5z6UY9Y1MCSEZm3qluGXVlUc/Mr
X-Google-Smtp-Source: ALg8bN4pL0IkwbSjBySvGJvxkde7VuDHdq22K47QfLKYDjjNQKluD6+sMkE88nxgVzDa7j59YM5ZlQ==
X-Received: by 2002:adf:c108:: with SMTP id r8mr11406554wre.233.1547157828082; 
 Thu, 10 Jan 2019 14:03:48 -0800 (PST)
Received: from lolita.yourcompany.com (188.139.62.94.rev.vodafone.pt.
 [94.62.139.188])
 by smtp.gmail.com with ESMTPSA id p6sm75092063wrx.50.2019.01.10.14.03.47
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Thu, 10 Jan 2019 14:03:47 -0800 (PST)
From: =?UTF-8?Q?Jo=C3=A3o_?= =?UTF-8?Q?T=C3=A1vora?= <joaotavora@HIDDEN>
References: <1547066017.2291240.1630221536.19E9AC39@HIDDEN>
 <87ftu1lfka.fsf@HIDDEN>
 <1547154402.1640373.1631290352.72E71BD4@HIDDEN>
Date: Thu, 10 Jan 2019 22:03:44 +0000
In-Reply-To: <1547154402.1640373.1631290352.72E71BD4@HIDDEN>
 ("Johann \=\?utf-8\?Q\?Kl\=C3\=A4hn\=22's\?\= message of "Thu,
 10 Jan 2019 22:06:42 +0100")
Message-ID: <87bm4omapr.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
 recognized.
X-Received-From: 2a00:1450:4864:20::42d
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Spam-Score: 1.1 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Johann =?UTF-8?Q?Kl=C3=A4hn?= writes: > thanks for your quick response! I
   did not see > `flymake-overlay-control' because I was still using the version
    of > flymake shipped with Emacs 26.1. (I really like the options introduced
    > with the [...] 
 
 Content analysis details:   (1.1 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  1.0 SPF_SOFTFAIL           SPF: sender does not match SPF record (softfail)
  0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
                             provider (joaotavora[at]gmail.com)
  0.1 FROM_EXCESS_BASE64     From: base64 encoded unnecessarily
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.1 (/)

Johann Kl=C3=A4hn <johann@HIDDEN> writes:

> thanks for your quick response! I did not see
> `flymake-overlay-control' because I was still using the version of
> flymake shipped with Emacs 26.1. (I really like the options introduced
> with the new version allows, so I will probably switch to using it.)

Flymake is now also distributed through ELPA, so you can use the most
recent version even on Emacs 26.1

> =E2=80=96 =E2=80=98priority=E2=80=99
> =E2=80=96      This property=E2=80=99s value determines the priority of t=
he overlay.  If
> =E2=80=96      you want to specify a priority value, use either =E2=80=98=
nil=E2=80=99 (or zero),
> =E2=80=96      or a positive integer.  Any other value has undefined beha=
vior.
> =E2=80=96      [...]
> =E2=80=96      Note that Emacs sometimes uses non-numeric priority values=
 for some
> =E2=80=96      of its internal overlays, so do not try to do arithmetic o=
n the
> =E2=80=96      priority of an overlay (unless it is one that you created)=
.  In
> =E2=80=96      particular, the overlay used for showing the region uses a=
 priority
> =E2=80=96      value of the form =E2=80=98(PRIMARY . SECONDARY)=E2=80=99,=
 where the PRIMARY value
> =E2=80=96      is used as described above, and SECONDARY is the fallback =
value
> =E2=80=96      used when PRIMARY and the nesting considerations fail to r=
esolve
> =E2=80=96      the precedence between overlays.  However, you are advised=
 not to
> =E2=80=96      design Lisp programs based on this implementation detail; =
if you
> =E2=80=96      need to put overlays in priority order, use the SORTED arg=
ument of
> =E2=80=96      =E2=80=98overlays-at=E2=80=99.  *Note Finding Overlays::.
>
> Even though it's shipped with Emacs, flymake is probably not
> "internal" enough to use those?

Good point.  Don't know how to fix it then.

> ...looking around further I just found Bug#16192, where a similar
> problem was fixed for hl-line-mode by using a negative priority.  And
> then there is also Bug#15899, which discusses the use of overlays to
> highlight region in the first place.
>
I remember reading somewhere negative priorites were a nono, maybe that
has changed.

Jo=C3=A3o




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#34022: 26.1; Region highlight has lower priority than flymake overlays
Resent-From: =?UTF-8?Q?Jo=C3=A3o_?= =?UTF-8?Q?T=C3=A1vora?= <joaotavora@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Fri, 11 Jan 2019 09:34:01 +0000
Resent-Message-ID: <handler.34022.B34022.154719922623767 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 34022
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Eli Zaretskii <eliz@HIDDEN>
Cc: 34022 <at> debbugs.gnu.org, Johann =?UTF-8?Q?Kl=C3=A4hn?= <johann@HIDDEN>
Received: via spool by 34022-submit <at> debbugs.gnu.org id=B34022.154719922623767
          (code B ref 34022); Fri, 11 Jan 2019 09:34:01 +0000
Received: (at 34022) by debbugs.gnu.org; 11 Jan 2019 09:33:46 +0000
Received: from localhost ([127.0.0.1]:54617 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ghtCE-0006BH-6J
	for submit <at> debbugs.gnu.org; Fri, 11 Jan 2019 04:33:46 -0500
Received: from mail-wr1-f46.google.com ([209.85.221.46]:40160)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <joaotavora@HIDDEN>) id 1ghtCC-0006B5-Qc
 for 34022 <at> debbugs.gnu.org; Fri, 11 Jan 2019 04:33:45 -0500
Received: by mail-wr1-f46.google.com with SMTP id p4so14402838wrt.7
 for <34022 <at> debbugs.gnu.org>; Fri, 11 Jan 2019 01:33:44 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version:content-transfer-encoding;
 bh=nCKZPNHKvdnxOa8O3wb/oOUYjg+DW0MSlulKpbD1NsA=;
 b=qm5gyHWix9vodv8PmQSlB918KmLT6Rtl0hRLwwuItvYVoKdGXhjdQ73dQPajQCuFu/
 kRIKc5uBQ51qRH/PfKvY8FC4C8+HNjiQUbGAGkI8yCJ0PEGk4skfve4U8fqUCvqHaQjh
 7hdidpoJg6lPHtwqsC4gfU3I+NkvoXWcS0ad71OEsGnB9IJpbpu4b11LRnJxjTZtr8hC
 Lyp116a+qkRXv+1tijShL8vF2ESA+eyjlgAs2BkZgsMGxNU9Ep3hVOvEH7kD/vh6YZi9
 JzTLgjHYdGESmVHjyzy0qq6W6iGq0P7PbUnZFSIQ9JebW9xkgbRaJE1DAmxGnjvApBgn
 z7kg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version:content-transfer-encoding;
 bh=nCKZPNHKvdnxOa8O3wb/oOUYjg+DW0MSlulKpbD1NsA=;
 b=qeYtNec95QBd2IZPyUZmE+dKVn1LrdJt/m2ZFr8Qgn4FWScRKbTVhrQjxM4reJDmiC
 iM+geJkcrhUzlFSnC8yqYi5XFu7DkGmKPlI70wP3o8qbu/UP9Abs6/pGLbLD4COxtdra
 6BsPeD2BN126zMR2V5DfaFRH/5Anm41RX/L/cvMXQbiy3yjyVz6edAf4RoBEqGhbnq2C
 YxpUqTEs/E4SLT6N2y1zMWa7Jbf0AAPW57gfMVWA463G6Pqh7HnFrODTkuCAdTLsOMaD
 uhu9olUKN13IC5AD6wKFVuY3rzeJdvuuLZWXeOVGgT9sswZLirBkXtajKxkUCeui9gZu
 HH0Q==
X-Gm-Message-State: AJcUukfeWwGPFM5DfcOMjxBmye4+KMIFkO7iBrJScN33g4eqKpYuLhC2
 oT3f5CLPczYbbHXNJ7gOkHl/0nso
X-Google-Smtp-Source: ALg8bN7NY5RR7W/Mmy7iIDfe4WZ5/3dURho9RQY+kmlSuuF/2WUgidZ+bmct+hpIT9rzlrPBXmFjFQ==
X-Received: by 2002:adf:df01:: with SMTP id y1mr13141813wrl.127.1547199218575; 
 Fri, 11 Jan 2019 01:33:38 -0800 (PST)
Received: from lolita.yourcompany.com (188.139.62.94.rev.vodafone.pt.
 [94.62.139.188])
 by smtp.gmail.com with ESMTPSA id u10sm54036022wrr.33.2019.01.11.01.33.37
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Fri, 11 Jan 2019 01:33:37 -0800 (PST)
From: =?UTF-8?Q?Jo=C3=A3o_?= =?UTF-8?Q?T=C3=A1vora?= <joaotavora@HIDDEN>
References: <1547066017.2291240.1630221536.19E9AC39@HIDDEN>
 <87ftu1lfka.fsf@HIDDEN>
 <1547153959.1638293.1631244736.794AFB75@HIDDEN>
 <83o98nhcst.fsf@HIDDEN>
Date: Fri, 11 Jan 2019 09:33:33 +0000
In-Reply-To: <83o98nhcst.fsf@HIDDEN> (Eli Zaretskii's message of "Fri, 11 Jan
 2019 09:29:54 +0200")
Message-ID: <877efbmtci.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.1 (/)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.9 (/)

[BTW Johann: to CC the bug tracker, use 34022 <at> debbugs.gnu.org, not
bug-gnu-emacs@HIDDEN, since this will create a new bug, and has the
potential to annoy maintainers :-).  I'm guilty of that too, since I
replied to all in the email you did that (and so created another bug).]

Eli Zaretskii <eliz@HIDDEN> writes:

> I'm not sure what I'm supposed to chime in about.  Are you asking
> whether it's okay for Flymake to use the same technique as the
> region's overlay?

I guess he is, yes.  It's a problem I didn't encounter during
development because the face properties of the Flymake overlays and the
region don't clash when using the default settings.

> Or are you asking something else?  If the former,
> I'm not sure I understand the problem well enough to answer the
> question.

In Flymake multiple overlays (error, warning, note) can overlap and
priorities are used so that an error is never hidden by a note.  I based
thosed priorities in the 100's range (so note =3D 101, warning=3D102,
error=3D103, sth like that). 100 was a number chosen quite arbitrarily
which worked fine until Johann noticed the bug (I do think it's a bug).

>In particular, how is Flymake different from any other package which
>uses overlays to mark portions of text?

Perhaps it isn't.  Can you point me to other packages that leave
persistent region-resisting overlays in the buffer? (or that "play nice"
with the region, for some meaning of "nice").

Jo=C3=A3o







Last modified: Fri, 11 Jan 2019 09:45:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.